diff --git a/gcc/tree-vect-loop.c b/gcc/tree-vect-loop.c
index 4ce721ed..55d7aaf 100644
--- a/gcc/tree-vect-loop.c
+++ b/gcc/tree-vect-loop.c
@@ -1959,13 +2010,13 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
      touching this loop.  */
   if (!need_to_vectorize)
     {
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_NOTE, vect_location,
-			 "All the computation can be taken out of the loop.\n");
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: redundant loop. no profit to "
-			 "vectorize.\n");
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_REMARK,
+			       "All the computation can be taken out of the loop");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: redundant loop. no profit to "
+			       "vectorize");
       return false;
     }
 
@@ -1996,10 +2047,10 @@ vect_analyze_loop_costing (loop_vec_info loop_vinfo)
       if (max_niter != -1
 	  && (unsigned HOST_WIDE_INT) max_niter < assumed_vf)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			     "not vectorized: iteration count smaller than "
-			     "vectorization factor.\n");
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
+				   "not vectorized: iteration count smaller than "
+				   "vectorization factor");
 	  return 0;
 	}
     }
@@ -2010,13 +2061,13 @@ vect_analyze_loop_costing (loop_vec_info loop_vinfo)
 
   if (min_profitable_iters < 0)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: vectorization not profitable.\n");
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: vector version will never be "
-			 "profitable.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: vectorization not profitable");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: vector version will never be "
+			       "profitable");
       return -1;
     }
 
@@ -2033,14 +2084,14 @@ vect_analyze_loop_costing (loop_vec_info loop_vinfo)
   if (LOOP_VINFO_NITERS_KNOWN_P (loop_vinfo)
       && LOOP_VINFO_INT_NITERS (loop_vinfo) < th)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: vectorization not profitable.\n");
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_NOTE, vect_location,
-			 "not vectorized: iteration count smaller than user "
-			 "specified loop bound parameter or minimum profitable "
-			 "iterations (whichever is more conservative).\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: vectorization not profitable");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_REMARK,
+			       "not vectorized: iteration count smaller than user "
+			       "specified loop bound parameter or minimum profitable "
+			       "iterations (whichever is more conservative)");
       return 0;
     }
 
@@ -2051,16 +2102,16 @@ vect_analyze_loop_costing (loop_vec_info loop_vinfo)
       && ((unsigned HOST_WIDE_INT) estimated_niter
 	  < MAX (th, (unsigned) min_profitable_estimate)))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: estimated iteration count too "
-			 "small.\n");
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_NOTE, vect_location,
-			 "not vectorized: estimated iteration count smaller "
-			 "than specified loop bound parameter or minimum "
-			 "profitable iterations (whichever is more "
-			 "conservative).\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: estimated iteration count too "
+			       "small");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_REMARK,
+			       "not vectorized: estimated iteration count smaller "
+			       "than specified loop bound parameter or minimum "
+			       "profitable iterations (whichever is more "
+			       "conservative)");
       return -1;
     }
 
@@ -2093,11 +2144,11 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   loop_p loop = LOOP_VINFO_LOOP (loop_vinfo);
   if (!find_loop_nest (loop, &LOOP_VINFO_LOOP_NEST (loop_vinfo)))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "not vectorized: loop nest containing two "
-			 "or more consecutive inner loops cannot be "
-			 "vectorized\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "not vectorized: loop nest containing two "
+			       "or more consecutive inner loops cannot be "
+			       "vectorized");
       return false;
     }
 
@@ -2142,11 +2193,11 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
 		      }
 		  }
 	      }
-	    if (dump_enabled_p ())
-	      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			       "not vectorized: loop contains function "
-			       "calls or data references that cannot "
-			       "be analyzed\n");
+	    if (thing_enabled_p ())
+	      vect_location_writeln (OPT_RECORD_FAILURE,
+				     "not vectorized: loop contains function "
+				     "calls or data references that cannot "
+				     "be analyzed");
 	    return false;
 	  }
       }
@@ -2157,9 +2208,9 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   ok = vect_analyze_data_refs (loop_vinfo, &min_vf);
   if (!ok)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "bad data references.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "bad data references");
       return false;
     }
 
@@ -2177,9 +2228,9 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   ok = vect_analyze_data_ref_accesses (loop_vinfo);
   if (!ok)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "bad data access.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "bad data access");
       return false;
     }
 
@@ -2188,9 +2239,9 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   ok = vect_mark_stmts_to_be_vectorized (loop_vinfo);
   if (!ok)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-			 "unexpected pattern.\n");
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
+			       "unexpected pattern");
       return false;
     }
 
@@ -2207,8 +2258,8 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
       || (max_vf != MAX_VECTORIZATION_FACTOR
 	  && maybe_lt (max_vf, min_vf)))
     {
-      if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "bad data dependence.\n");
       return false;
     }
@@ -2217,16 +2268,16 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   ok = vect_determine_vectorization_factor (loop_vinfo);
   if (!ok)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "can't determine vectorization factor.\n");
       return false;
     }
   if (max_vf != MAX_VECTORIZATION_FACTOR
       && maybe_lt (max_vf, LOOP_VINFO_VECT_FACTOR (loop_vinfo)))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "bad data dependence.\n");
       return false;
     }
@@ -2266,9 +2317,9 @@ start_over:
   poly_uint64 vectorization_factor = LOOP_VINFO_VECT_FACTOR (loop_vinfo);
   gcc_assert (known_ne (vectorization_factor, 0U));
 
-  if (LOOP_VINFO_NITERS_KNOWN_P (loop_vinfo) && dump_enabled_p ())
+  if (LOOP_VINFO_NITERS_KNOWN_P (loop_vinfo) && thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location,
+      vect_location_writeln (OPT_RECORD_REMARK,
 		       "vectorization_factor = ");
       dump_dec (MSG_NOTE, vectorization_factor);
       dump_printf (MSG_NOTE, ", niters = " HOST_WIDE_INT_PRINT_DEC "\n",
@@ -2284,8 +2335,8 @@ start_over:
   ok = vect_analyze_data_refs_alignment (loop_vinfo);
   if (!ok)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "bad data alignment.\n");
       return false;
     }
@@ -2306,8 +2357,8 @@ start_over:
     ok = vect_enhance_data_refs_alignment (loop_vinfo);
     if (!ok)
       {
-	if (dump_enabled_p ())
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	if (thing_enabled_p ())
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 			   "bad data alignment.\n");
         return false;
       }
@@ -2329,8 +2380,8 @@ start_over:
   ok = vect_analyze_loop_operations (loop_vinfo);
   if (!ok)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "bad operation or unsupported loop bound.\n");
       return false;
     }
@@ -2340,13 +2391,13 @@ start_over:
   LOOP_VINFO_FULLY_MASKED_P (loop_vinfo)
     = (LOOP_VINFO_CAN_FULLY_MASK_P (loop_vinfo)
        && vect_verify_full_masking (loop_vinfo));
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
       if (LOOP_VINFO_FULLY_MASKED_P (loop_vinfo))
-	dump_printf_loc (MSG_NOTE, vect_location,
+	vect_location_writeln (OPT_RECORD_REMARK,
 			 "using a fully-masked loop.\n");
       else
-	dump_printf_loc (MSG_NOTE, vect_location,
+	vect_location_writeln (OPT_RECORD_REMARK,
 			 "not using a fully-masked loop.\n");
     }
 
@@ -2362,8 +2413,8 @@ start_over:
 
       if (known_lt (wi::to_widest (scalar_niters), vf))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_NOTE, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_REMARK,
 			     "loop has no enough iterations to support"
 			     " peeling for gaps.\n");
 	  return false;
@@ -2376,8 +2427,8 @@ start_over:
     goto again;
   if (!res)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "Loop costings not worthwhile.\n");
       return false;
     }
@@ -2414,15 +2465,15 @@ start_over:
   if (LOOP_VINFO_PEELING_FOR_GAPS (loop_vinfo)
       || LOOP_VINFO_PEELING_FOR_NITER (loop_vinfo))
     {
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_NOTE, vect_location, "epilog loop required\n");
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_REMARK, "epilog loop required\n");
       if (!vect_can_advance_ivs_p (loop_vinfo)
 	  || !slpeel_can_duplicate_loop_p (LOOP_VINFO_LOOP (loop_vinfo),
 					   single_exit (LOOP_VINFO_LOOP
 							 (loop_vinfo))))
         {
-          if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "not vectorized: can't create required "
 			     "epilog loop\n");
           goto again;
@@ -2509,8 +2560,8 @@ again:
 	}
     }
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
 		     "re-trying with SLP disabled\n");
 
   /* Roll back state appropriately.  No SLP this time.  */
@@ -2587,16 +2638,16 @@ vect_analyze_loop (struct loop *loop, loop_vec_info orig_loop_vinfo)
   targetm.vectorize.autovectorize_vector_sizes (&vector_sizes);
   unsigned int next_size = 0;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
-		     "===== analyze_loop_nest =====\n");
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
+			   "===== analyze_loop_nest =====");
 
   if (loop_outer (loop)
       && loop_vec_info_for_loop (loop_outer (loop))
       && LOOP_VINFO_VECTORIZABLE_P (loop_vec_info_for_loop (loop_outer (loop))))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_NOTE, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_REMARK,
 			 "outer-loop already vectorized.\n");
       return NULL;
     }
@@ -2608,8 +2659,8 @@ vect_analyze_loop (struct loop *loop, loop_vec_info orig_loop_vinfo)
       loop_vinfo = vect_analyze_loop_form (loop);
       if (!loop_vinfo)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "bad loop form.\n");
 	  return NULL;
 	}
@@ -2642,9 +2693,9 @@ vect_analyze_loop (struct loop *loop, loop_vec_info orig_loop_vinfo)
 
       /* Try the next biggest vector size.  */
       current_vector_size = vector_sizes[next_size++];
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "***** Re-trying analysis with "
 			   "vector size ");
 	  dump_dec (MSG_NOTE, current_vector_size);
@@ -2945,9 +2996,9 @@ vect_is_slp_reduction (loop_vec_info loop_info, gimple *phi,
                                   == vect_internal_def
                       && !is_loop_header_bb_p (gimple_bb (def_stmt)))))
   	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_NOTE, vect_location, "swapping oprnds: ");
+		  vect_location_writeln (OPT_RECORD_REMARK, "swapping oprnds: ");
 		  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, next_stmt, 0);
 		}
 
@@ -3201,8 +3252,8 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
 
       if (!flow_bb_inside_loop_p (loop, gimple_bb (use_stmt)))
         {
-          if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "intermediate value used outside loop.\n");
 
           return NULL;
@@ -3211,8 +3262,8 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
       nloop_uses++;
       if (nloop_uses > 1)
         {
-          if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "reduction value used in loop.\n");
           return NULL;
         }
@@ -3224,9 +3275,9 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
   tree loop_arg = PHI_ARG_DEF_FROM_EDGE (phi, latch_e);
   if (TREE_CODE (loop_arg) != SSA_NAME)
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 			   "reduction: not ssa_name: ");
 	  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, loop_arg);
           dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -3247,9 +3298,9 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
     }
   else
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 			   "reduction: unhandled reduction operation: ");
 	  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, def_stmt, 0);
 	}
@@ -3273,8 +3324,8 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
 	lcphis.safe_push (as_a <gphi *> (use_stmt));
       if (nloop_uses > 1)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "reduction used in loop.\n");
 	  return NULL;
 	}
@@ -3289,8 +3340,8 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
       if (gimple_phi_num_args (def_stmt) != 1
           || TREE_CODE (op1) != SSA_NAME)
         {
-          if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "unsupported phi node definition.\n");
 
           return NULL;
@@ -3304,7 +3355,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
           && is_gimple_assign (def1)
 	  && flow_bb_inside_loop_p (loop->inner, gimple_bb (phi_use_stmt)))
         {
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             report_vect_op (MSG_NOTE, def_stmt,
 			    "detected double reduction: ");
 
@@ -3358,7 +3409,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
         }
       if (op3 == phi_name || op4 == phi_name)
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    report_vect_op (MSG_MISSED_OPTIMIZATION, def_stmt,
 			    "reduction: condition depends on previous"
 			    " iteration: ");
@@ -3370,7 +3421,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
     }
   else if (!commutative_tree_code (code) || !associative_tree_code (code))
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	report_vect_op (MSG_MISSED_OPTIMIZATION, def_stmt,
 			"reduction: not commutative/associative: ");
       return NULL;
@@ -3382,7 +3433,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
     }
   else
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	report_vect_op (MSG_MISSED_OPTIMIZATION, def_stmt,
 			"reduction: not handled operation: ");
       return NULL;
@@ -3390,7 +3441,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
 
   if (TREE_CODE (op1) != SSA_NAME && TREE_CODE (op2) != SSA_NAME)
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	report_vect_op (MSG_MISSED_OPTIMIZATION, def_stmt,
 			"reduction: both uses not ssa_names: ");
 
@@ -3407,9 +3458,9 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
       || (op4 && TREE_CODE (op4) == SSA_NAME
           && !types_compatible_p (type, TREE_TYPE (op4))))
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
         {
-          dump_printf_loc (MSG_NOTE, vect_location,
+          vect_location_writeln (OPT_RECORD_REMARK,
 			   "reduction: multiple types: operation type: ");
           dump_generic_expr (MSG_NOTE, TDF_SLIM, type);
           dump_printf (MSG_NOTE, ", operands types: ");
@@ -3463,7 +3514,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
   if (code != COND_EXPR
       && ((!def1 || gimple_nop_p (def1)) && (!def2 || gimple_nop_p (def2))))
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	report_vect_op (MSG_NOTE, def_stmt, "reduction: no defs for operands: ");
       return NULL;
     }
@@ -3486,7 +3537,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
                           == vect_internal_def
  	              && !is_loop_header_bb_p (gimple_bb (def1)))))))
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	report_vect_op (MSG_NOTE, def_stmt, "detected reduction: ");
       return def_stmt;
     }
@@ -3531,7 +3582,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
 		}
 	      else
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    report_vect_op (MSG_NOTE, def_stmt,
 				    "detected reduction: cannot swap operands "
 				    "for cond_expr");
@@ -3542,7 +3593,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
 	    swap_ssa_operands (def_stmt, gimple_assign_rhs1_ptr (def_stmt),
 			       gimple_assign_rhs2_ptr (def_stmt));
 
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    report_vect_op (MSG_NOTE, def_stmt,
 			    "detected reduction: need to swap operands: ");
 
@@ -3551,7 +3602,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
         }
       else
         {
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             report_vect_op (MSG_NOTE, def_stmt, "detected reduction: ");
         }
 
@@ -3564,7 +3615,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
       && orig_code != MINUS_EXPR
       && vect_is_slp_reduction (loop_info, phi, def_stmt))
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
         report_vect_op (MSG_NOTE, def_stmt,
 			"reduction: detected reduction chain: ");
 
@@ -3586,7 +3637,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
 			    code))
     return def_stmt;
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
       report_vect_op (MSG_MISSED_OPTIMIZATION, def_stmt,
 		      "reduction: unknown pattern: ");
@@ -3634,8 +3685,8 @@ vect_get_known_peeling_cost (loop_vec_info loop_vinfo, int peel_iters_prologue,
   if (!LOOP_VINFO_NITERS_KNOWN_P (loop_vinfo))
     {
       *peel_iters_epilogue = assumed_vf / 2;
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_NOTE, vect_location,
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_REMARK,
 			 "cost model: epilogue peel iters set to vf/2 "
 			 "because loop iterations are unknown .\n");
 
@@ -3720,7 +3771,7 @@ vect_estimate_min_profitable_iters (loop_vec_info loop_vinfo,
   /* Cost model disabled.  */
   if (unlimited_cost_model (LOOP_VINFO_LOOP (loop_vinfo)))
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "cost model disabled.\n");
+      vect_location_writeln (OPT_RECORD_REMARK, "cost model disabled.\n");
       *ret_min_profitable_niters = 0;
       *ret_min_profitable_estimate = 0;
       return;
@@ -3980,9 +4031,9 @@ vect_estimate_min_profitable_iters (loop_vec_info loop_vinfo,
 
   vec_outside_cost = (int)(vec_prologue_cost + vec_epilogue_cost);
   
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "Cost model analysis: \n");
+      vect_location_writeln (OPT_RECORD_REMARK, "Cost model analysis: \n");
       dump_printf (MSG_NOTE, "  Vector inside of loop cost: %d\n",
                    vec_inside_cost);
       dump_printf (MSG_NOTE, "  Vector prologue cost: %d\n",
@@ -4038,8 +4089,8 @@ vect_estimate_min_profitable_iters (loop_vec_info loop_vinfo,
 	warning_at (vect_location, OPT_Wopenmp_simd, "vectorization "
 		    "did not happen for a simd loop");
 
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_FAILURE,
 			 "cost model: the vector iteration cost = %d "
 			 "divided by the scalar iteration cost = %d "
 			 "is greater or equal to the vectorization factor = %d"
@@ -4059,8 +4110,8 @@ vect_estimate_min_profitable_iters (loop_vec_info loop_vinfo,
     /* We want the vectorized loop to execute at least once.  */
     min_profitable_iters = assumed_vf + peel_iters_prologue;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "  Runtime profitability threshold = %d\n",
                      min_profitable_iters);
 
@@ -4085,8 +4136,8 @@ vect_estimate_min_profitable_iters (loop_vec_info loop_vinfo,
 				   - vec_inside_cost);
     }
   min_profitable_estimate = MAX (min_profitable_estimate, min_profitable_iters);
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
 		     "  Static estimate profitability threshold = %d\n",
 		     min_profitable_estimate);
 
@@ -4307,7 +4358,7 @@ vect_model_reduction_cost (stmt_vec_info stmt_info, internal_fn reduc_fn,
 	}
     }
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     dump_printf (MSG_NOTE, 
                  "vect_model_reduction_cost: inside_cost = %d, "
                  "prologue_cost = %d, epilogue_cost = %d .\n", inside_cost,
@@ -4337,8 +4388,8 @@ vect_model_induction_cost (stmt_vec_info stmt_info, int ncopies)
   prologue_cost = add_stmt_cost (target_cost_data, 2, scalar_to_vec,
 				 stmt_info, 0, vect_prologue);
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "vect_model_induction_cost: inside_cost = %d, "
                      "prologue_cost = %d .\n", inside_cost, prologue_cost);
 }
@@ -4930,9 +4981,9 @@ vect_create_epilog_for_reduction (vec<tree> vect_defs, gimple *stmt,
           add_phi_arg (as_a <gphi *> (phi), def, loop_latch_edge (loop),
 		       UNKNOWN_LOCATION);
 
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_NOTE, vect_location,
+              vect_location_writeln (OPT_RECORD_REMARK,
 			       "transform reduction: created def-use cycle: ");
               dump_gimple_stmt (MSG_NOTE, TDF_SLIM, phi, 0);
               dump_gimple_stmt (MSG_NOTE, TDF_SLIM, SSA_NAME_DEF_STMT (def), 0);
@@ -5419,8 +5470,8 @@ vect_create_epilog_for_reduction (vec<tree> vect_defs, gimple *stmt,
       /* Case 1:  Create:
          v_out2 = reduc_expr <v_out1>  */
 
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_NOTE, vect_location,
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_REMARK,
 			 "Reduce using direct vector reduction.\n");
 
       vec_elem_type = TREE_TYPE (TREE_TYPE (new_phi_result));
@@ -5690,8 +5741,8 @@ vect_create_epilog_for_reduction (vec<tree> vect_defs, gimple *stmt,
 
           tree rhs;
 
-          if (dump_enabled_p ())
-            dump_printf_loc (MSG_NOTE, vect_location,
+          if (thing_enabled_p ())
+            vect_location_writeln (OPT_RECORD_REMARK,
 			     "Reduce using vector shifts\n");
 
 	  mode1 = TYPE_MODE (vectype1);
@@ -5719,8 +5770,8 @@ vect_create_epilog_for_reduction (vec<tree> vect_defs, gimple *stmt,
 	  /* 2.4  Extract the final scalar result.  Create:
 	     s_out3 = extract_field <v_out2, bitpos>  */
 
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_NOTE, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_REMARK,
 			     "extract scalar result\n");
 
 	  rhs = build3 (BIT_FIELD_REF, scalar_type, new_temp,
@@ -5743,8 +5794,8 @@ vect_create_epilog_for_reduction (vec<tree> vect_defs, gimple *stmt,
                  Create:  s = op <s, s'>  // For non SLP cases
                }  */
 
-          if (dump_enabled_p ())
-            dump_printf_loc (MSG_NOTE, vect_location,
+          if (thing_enabled_p ())
+            vect_location_writeln (OPT_RECORD_REMARK,
 			     "Reduce using scalar code.\n");
 
 	  int vec_size_in_bits = tree_to_uhwi (TYPE_SIZE (vectype1));
@@ -6066,9 +6117,9 @@ vect_finalize_reduction:
                                UNKNOWN_LOCATION);
                   add_phi_arg (vect_phi, PHI_RESULT (inner_phi),
                                loop_latch_edge (outer_loop), UNKNOWN_LOCATION);
-                  if (dump_enabled_p ())
+                  if (thing_enabled_p ())
                     {
-                      dump_printf_loc (MSG_NOTE, vect_location,
+                      vect_location_writeln (OPT_RECORD_REMARK,
 				       "created double reduction phi node: ");
                       dump_gimple_stmt (MSG_NOTE, TDF_SLIM, vect_phi, 0);
                     }
@@ -6749,8 +6800,8 @@ vectorizable_reduction (gimple *stmt, gimple_stmt_iterator *gsi,
     {
       if (STMT_VINFO_REDUC_TYPE (stmt_info) == FOLD_LEFT_REDUCTION)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "in-order reduction chain without SLP.\n");
 	  return false;
 	}
@@ -6803,8 +6854,8 @@ vectorizable_reduction (gimple *stmt, gimple_stmt_iterator *gsi,
 	 as a reduction operation.  */
       if (reduc_index == -1)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "conditional reduction chains not supported\n");
 	  return false;
 	}
@@ -6828,8 +6879,8 @@ vectorizable_reduction (gimple *stmt, gimple_stmt_iterator *gsi,
       else if (direct_internal_fn_supported_p (IFN_FOLD_EXTRACT_LAST,
 					       vectype_in, OPTIMIZE_FOR_SPEED))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "optimizing condition reduction with"
 			     " FOLD_EXTRACT_LAST.\n");
 	  STMT_VINFO_VEC_REDUCTION_TYPE (stmt_info) = EXTRACT_LAST_REDUCTION;
@@ -6869,8 +6920,8 @@ vectorizable_reduction (gimple *stmt, gimple_stmt_iterator *gsi,
 	    }
 	  if (cond_reduc_val)
 	    {
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_NOTE, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_REMARK,
 				 "condition expression based on "
 				 "integer induction.\n");
 	      STMT_VINFO_VEC_REDUCTION_TYPE (stmt_info)
@@ -6895,8 +6946,8 @@ vectorizable_reduction (gimple *stmt, gimple_stmt_iterator *gsi,
 				    cond_initial_val, cond_reduc_val);
 	      if (e && (integer_onep (e) || integer_zerop (e)))
 		{
-		  if (dump_enabled_p ())
-		    dump_printf_loc (MSG_NOTE, vect_location,
+		  if (thing_enabled_p ())
+		    vect_location_writeln (OPT_RECORD_REMARK,
 				     "condition expression based on "
 				     "compile time constant.\n");
 		  /* Record reduction code at analysis stage.  */
@@ -6938,8 +6989,8 @@ vectorizable_reduction (gimple *stmt, gimple_stmt_iterator *gsi,
       if (!vec_stmt && !vectorizable_condition (stmt, gsi, NULL,
 						ops[reduc_index], 0, NULL))
         {
-          if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "unsupported condition in reduction\n");
 	  return false;
         }
@@ -6953,8 +7004,8 @@ vectorizable_reduction (gimple *stmt, gimple_stmt_iterator *gsi,
 	{
 	  /* Shifts and rotates are only supported by vectorizable_shifts,
 	     not vectorizable_reduction.  */
-          if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "unsupported shift or rotation.\n");
 	  return false;
 	}
@@ -6963,8 +7014,8 @@ vectorizable_reduction (gimple *stmt, gimple_stmt_iterator *gsi,
       optab = optab_for_tree_code (code, vectype_in, optab_default);
       if (!optab)
         {
-          if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "no optab.\n");
 
           return false;
@@ -6972,14 +7023,14 @@ vectorizable_reduction (gimple *stmt, gimple_stmt_iterator *gsi,
 
       if (optab_handler (optab, vec_mode) == CODE_FOR_nothing)
         {
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             dump_printf (MSG_NOTE, "op not supported by target.\n");
 
 	  if (maybe_ne (GET_MODE_SIZE (vec_mode), UNITS_PER_WORD)
 	      || !vect_worthwhile_without_simd_p (loop_vinfo, code))
             return false;
 
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
   	    dump_printf (MSG_NOTE, "proceeding using word mode.\n");
         }
 
